---
layout: default
title: Resources
nav_order: 3
description: "Methods for single-cell proteomics developed in the Slavov Laboratory, Northeastern University, Boston"
permalink: mass-spec/sensitive-mass-spectrometry-analysis
parent: Optimization
---
{% include social-media-links.html %}


# Ultrasensitive mass-spectrometry analysis

&nbsp;

### Quantifying proteins in single cells at high-throughput with mass spectrometry

[SCoPE2 Preprint](https://doi.org/10.1101/665307){: .btn .fs-5 .mb-4 .mb-md-0 .mr-2 }[GitHub](https://github.com/SlavovLab/SCoPE2/tree/master/code){: .btn .fs-5 .mb-4 .mb-md-0 }[JPR Perspective](https://pubs.acs.org/doi/10.1021/acs.jproteome.8b00257){: .btn .fs-5 .mb-4 .mb-md-0 .mr-2}[Science Perspective](https://science.sciencemag.org/content/367/6477/512){: .btn .fs-5 .mb-4 .mb-md-0 .mr-2}

------------


## Methods and tools for optimizing sensitive mass spectrometry analysis
The sensitivity of mass spectrometry analysis depends on many factors, including sample preparations, data acquisition, and data interpretation. These factors can be benchmarked and optimized by methods developed in the [Slavov Laboratory](http://slavovlab.net):

* [Data-driven Optimization of Mass-Spectrometry (DO-MS)](https://do-ms.slavovlab.net)
* [Data-driven Alignment of Retention Times for IDentification (DART-ID)](https://dart-id.slavovlab.net)


[DO-MS](https://do-ms.slavovlab.net) and [DART-ID](https://dart-id.slavovlab.net) are major contributors to the increased throughput and quantitative accuracy of SCoPE2 compared to [Single-Cell ProtEomics by Mass Spectrometry (SCoPE-MS)](http://slavovlab.net/2016_SCoPE-MS/index.html). Below are video presentations by Gray Huffman and Albert Chen describing these methods.




&nbsp;

<iframe width="560" height="315" src="https://www.youtube.com/embed/XNyYZ8w_8jY" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>

&nbsp;

<iframe width="560" height="315" src="https://www.youtube.com/embed/IWeasIXs5F0" frameborder="0" allow="accelerometer; autoplay; encrypted-media; gyroscope; picture-in-picture" allowfullscreen></iframe>


## Principles for optimizing experiments using isobaric carriers

These [controlled experiments](https://www.biorxiv.org/content/10.1101/2020.08.24.264994v4) describe general principles and suggest guidelines for experiments using isobaric carriers.




## Further resources  

 * [Single-Cell Proteomics Center](http://center.single-cell.net)
 * [Single-cell Proteomics Conference](http://single-cell.net)
 * [Introduction to mass-spectrometry analysis](http://slavovlab.net/teaching/Methods-of-Bioengineering.html)



 Read more about the [single-cell proteomics research](http://slavovlab.net/research.htm#SCoPE-MS), its active [single-cell proteomics projects](http://center.single-cell.net/single-cell-proteomics/research) and [ultrasensitive MS analysis](https://scope2.slavovlab.net/mass-spec/single-cell-proteomics).

 &nbsp;

 &nbsp;
