---
layout: default
title: Single-cell proteomics
nav_order: 13
description: "Single-cell proteomics methods developed in the Slavov Laboratory, Northeastern University, Boston"
permalink: mass-spec/single-cell-proteomics
nav_exclude: true
---

# Single-cell proteomics

&nbsp;

### Quantifying proteins in single cells at high-throughput with mass spectrometry

[SCoPE2 Preprint](https://doi.org/10.1101/665307){: .btn .fs-5 .mb-4 .mb-md-0 .mr-2 }[GitHub](https://github.com/SlavovLab/SCoPE2/tree/master/code){: .btn .fs-5 .mb-4 .mb-md-0 }[JPR Perspective](https://pubs.acs.org/doi/10.1021/acs.jproteome.8b00257){: .btn .fs-5 .mb-4 .mb-md-0 .mr-2}[Science Perspective](https://science.sciencemag.org/content/367/6477/512){: .btn .fs-5 .mb-4 .mb-md-0 .mr-2}

------------

Recently, the throughput of single-cell transcriptomics and genomics technologies has increased more than a 1000-fold. This increase has powered new analyses: Whereas traditional analysis of bulk tissue averages all differences between the diverse cells comprising such samples, single-cell analysis characterizes each individual cell and thus has enabled the discovery and classification of previously unknown cell states. Yet, the nucleic-acid–based technologies are effectively blind to an important group of biological regulators: proteins. Fortunately, emerging mass-spectrometry (MS) technologies that identify and quantify proteins promise to deliver similar gains to single-cell protein analysis. These proteomic technologies will enable high-throughput investigation of key biological questions, such as signaling mechanisms based on protein binding, modifications, and degradation, that have long remained elusive.

&nbsp;

### Methods

* [Single-Cell ProtEomics by Mass Spectrometry (SCoPE-MS)](http://slavovlab.net/2016_SCoPE-MS/index.html)
* [Data-driven Alignment of Retention Times for IDentification (DART-ID)](https://dart-id.slavovlab.net)
* [Data-driven Optimization of Mass-Spectrometry (DO-MS)](https://do-ms.slavovlab.net)

&nbsp;

### Blog posts
 * [When do you need single-cell analysis?](https://web.northeastern.edu/slavovlab/blog/2019/08/14/when-do-you-need-single-cell-analysis/)
 * [Single-cell analysis](https://web.northeastern.edu/slavovlab/blog/2018/11/14/single-cell-analysis/)


&nbsp;


### Single-cell proteomics conference

We look forward to providing a stimulating [meeting](http://single-cell.net) of scientific exchanges and to welcoming you in Boston.

<div style="text-align: center;">
<a class="twitter-timeline" href="https://twitter.com/SCP_meeting" data-widget-id="499599916843274240">Tweets by @SCP_meeting</a>
<script>!function(d,s,id){var js,fjs=d.getElementsByTagName(s)[0],p=/^http:/.test(d.location)?'http':'https';if(!d.getElementById(id)){js=d.createElement(s);js.id=id;js.src=p+"://platform.twitter.com/widgets.js";fjs.parentNode.insertBefore(js,fjs);}}(document,"script","twitter-wjs");</script>
</div>
